<?php

namespace CRPlugins\Oca\Api;

abstract class JsonApi extends ApiConnector {

	public function before_request( string $method, string $url, array $body, array $headers ): array {
		$headers['Content-Type'] = 'application/json';
		$request                 = array(
			'method'  => $method,
			'headers' => $headers,
		);
		if ( ! empty( $body ) ) {
			$request['body'] = wp_json_encode( $body, JSON_UNESCAPED_UNICODE );
		}

		return $request;
	}

	public function after_request( string $response, array $args ): array {
		return array(
			'response' => json_decode( $response, true ),
			'request'  => $args,
		);
	}
}
