<?php

namespace CRPlugins\Oca\Helper;

use WC_Logger;

trait LoggerTrait {

	/**
	 * @var ?WC_Logger
	 */
	private static $logger;

	public static function init(): void {
		if ( function_exists( 'wc_get_logger' ) ) {
			if ( ! isset( self::$logger ) ) {
				self::$logger = wc_get_logger();
			}
		}
	}

	public static function log_info( $msg ): void {
		self::$logger->info( wc_print_r( $msg, true ), array( 'source' => 'WooCommerce Oca' ) );
	}

	public static function log_error( $msg ): void {
		self::$logger->error( wc_print_r( $msg, true ), array( 'source' => 'WooCommerce Oca' ) );
	}

	public static function log_warning( $msg ): void {
		self::$logger->warning( wc_print_r( $msg, true ), array( 'source' => 'WooCommerce Oca' ) );
	}

	public static function log_debug( $msg ): void {
		self::$logger->debug( wc_print_r( $msg, true ), array( 'source' => 'WooCommerce Oca' ) );
	}
}
