<?php

namespace CRPlugins\Oca\Settings\Fields;

final class CheckboxField extends Field {

	protected $data = array(
		'name'        => '',
		'slug'        => '',
		'type'        => 'checkbox',
		'description' => '',
		'default'     => '',
	);

	public function render() {
		$previous_config = filter_var( $this->get_value(), FILTER_VALIDATE_BOOLEAN ); // Bw compat

		printf(
			'<input type="hidden" name="%1$s" value="false"><input type="checkbox" name="%1$s" value="true" %2$s >',
			esc_attr( $this->get_slug() ),
			$previous_config ? 'checked' : ''
		);
		$desc = $this->get_description();
		if ( ! empty( $desc ) ) {
			printf( '<span class="field-description">%s<span>', esc_html( $desc ) );
		}
	}
}
