<?php

namespace CRPlugins\Oca\Settings\Fields;

abstract class Field implements FieldInterface {

	protected $data = array(
		'name'        => '',
		'slug'        => '',
		'type'        => '',
		'description' => '',
		'default'     => '',
		'placeholder' => '',
	);

	public function __construct( array $args ) {
		$this->data = wp_parse_args( $args, $this->data );
	}

	public function get_name() {
		return $this->data['name'];
	}

	public function get_slug() {
		return $this->data['slug'];
	}

	public function get_type() {
		return $this->data['type'];
	}

	public function get_default() {
		return $this->data['default'];
	}

	public function get_description() {
		return $this->data['description'];
	}

	public function get_placeholder() {
		return $this->data['placeholder'];
	}

	public function get_value() {
		return get_option( 'wc-oca-' . $this->data['slug'], $this->data['default'] );
	}

	abstract public function render();
}
