<?php

namespace CRPlugins\Oca\Settings\Fields;

final class TextField extends Field {

	protected $data = array(
		'name'        => '',
		'slug'        => '',
		'type'        => 'text',
		'description' => '',
		'default'     => '',
		'placeholder' => '',
	);

	public function render() {
		$previous_config = $this->get_value();
		printf(
			'<input type="text" id="%1$s" name="%1$s" value="%2$s" placeholder="%3$s" />',
			esc_attr( $this->get_slug() ),
			esc_attr( $previous_config ),
			esc_attr( $this->get_placeholder() )
		);
		$desc = $this->get_description();
		if ( ! empty( $desc ) ) {
			printf( '<span class="field-description">%s<span>', $desc );
		}
	}
}
