<?php

namespace CRPlugins\Oca\Settings\Sections;

use CRPlugins\Oca\Settings\FieldFactory;

/**
 * Base Section class
 */
class Section {

	private $data = array();

	/**
	 * Default constructor
	 *
	 * @param array $data
	 */
	public function __construct( array $data ) {
		$this->data = $data;
	}

	/**
	 * Adds the section itself into the settings page
	 *
	 * @return void
	 */
	public function add() {
		add_settings_section(
			$this->data['slug'],
			$this->data['name'],
			'',
			'wc-oca-settings'
		);

		$settings_fields = static::get_fields();
		foreach ( $settings_fields as $setting ) {
			add_settings_field(
				'wc-oca-' . $setting['slug'],
				$setting['name'],
				function () use ( $setting ) {
					$fFactory = new FieldFactory();
					$field    = $fFactory->create( $setting['slug'] );
					if ( $field !== false ) {
						$field->render();
					}
				},
				'wc-oca-settings',
				$this->data['slug']
			);
		}
	}

	public static function get_fields(): array {
		return array();
	}
}
