<?php

namespace CRPlugins\Oca\ShippingMethod;

class AjaxCalls {

	public function __construct() {
		add_action( 'wp_ajax_oca_update_shipping_branch', array( $this, 'set_shipping_branch' ) );
		add_action( 'wp_ajax_nopriv_oca_update_shipping_branch', array( $this, 'set_shipping_branch' ) );
	}

	public function set_shipping_branch() {
		if ( empty( $_POST['nonce'] ) || ! wp_verify_nonce( sanitize_key( $_POST['nonce'] ), 'wc-oca' ) || empty( $_POST['shipping_branch'] ) ) {
			wp_send_json_error( 'Wrong input!' );
		}
		if ( empty( $_POST['shipping_branch']['id'] ) || empty( $_POST['shipping_branch']['name'] ) || empty( $_POST['shipping_branch']['postcode'] ) ) {
			wp_send_json_error( 'Wrong input!' );
		}

		$shipping_branch['id']       = trim( sanitize_text_field( wp_unslash( $_POST['shipping_branch']['id'] ) ) );
		$shipping_branch['name']     = trim( sanitize_text_field( wp_unslash( $_POST['shipping_branch']['name'] ) ) );
		$shipping_branch['postcode'] = trim( sanitize_text_field( wp_unslash( $_POST['shipping_branch']['postcode'] ) ) );

		WC()->session->set( 'wc_oca_selected_shipping_branch', wp_json_encode( $shipping_branch ) );
		wp_send_json_success();
	}
}
