<?php

namespace CRPlugins\Oca\ValueObjects;

class Item {

	/**
	 * @var float
	 */
	private $height;
	/**
	 * @var float
	 */
	private $width;
	/**
	 * @var float
	 */
	private $length;
	/**
	 * @var float
	 */
	private $weight;
	/**
	 * @var float
	 */
	private $price;
	/**
	 * @var string
	 */
	private $name;
	/**
	 * @var int
	 */
	private $quantity;
	/**
	 * @var int
	 */
	private $id;

	public function __construct(
		$height,
		$width,
		$length,
		$weight,
		$price,
		$name,
		$quantity,
		$id
	) {
		$this->height   = (float) $height;
		$this->width    = (float) $width;
		$this->length   = (float) $length;
		$this->weight   = (float) $weight;
		$this->price    = (float) $price;
		$this->name     = $name;
		$this->quantity = (int) $quantity;
		$this->id       = (int) $id;
	}

	public function set_price( float $price ): void {
		$this->price = $price;
	}

	public function to_array(): array {
		return array(
			'height'   => $this->height(),
			'width'    => $this->width(),
			'length'   => $this->length(),
			'weight'   => $this->weight(),
			'price'    => $this->price(),
			'name'     => $this->name(),
			'quantity' => $this->quantity(),
			'id'       => $this->id(),
		);
	}

	public function height(): float {
		return $this->height;
	}

	public function width(): float {
		return $this->width;
	}

	public function length(): float {
		return $this->length;
	}

	public function weight(): float {
		return $this->weight;
	}

	public function price(): float {
		return $this->price;
	}

	public function name(): string {
		return $this->name;
	}

	public function quantity(): int {
		return $this->quantity;
	}

	public function id(): int {
		return $this->id;
	}
}
