<?php

use setasign\Fpdi\Fpdi;

require_once('fpdf/fpdf.php');
require_once('fpdi/autoload.php');

/**
 * Class to concatenate pdfs
 */
class OcaConcatPdf extends Fpdi
{
    public $files = [];

    public function setFiles(array $files)
    {
        $this->files = $files;
    }

    public function addFile(string $file)
    {
        $this->files[] = $file;
    }

    public function concat()
    {
        foreach ($this->files as $file) {
            $pageCount = $this->setSourceFile($file);
            for ($pageNo = 1; $pageNo <= $pageCount; $pageNo++) {
                $pageId = $this->ImportPage($pageNo);
                $s = $this->getTemplatesize($pageId);
                $this->AddPage($s['orientation'], $s);
                $this->useImportedPage($pageId);
            }
        }
    }
}
